#include "SDK/foobar2000.h"
#include "helpers/helpers.h"
#include "resource.h"

using namespace pfc;

COPYDATASTRUCT msndata;

// {10845646-3391-4931-B217-A22D3414F33B}
static const GUID cfg_title_guid =
{ 0x10845646, 0x3391, 0x4931, { 0xb2, 0x17, 0xa2, 0x2d, 0x34, 0x14, 0xf3, 0x3b } };
// {8ADA0C53-2EB8-4389-9FEC-457D2C2C2C01}
static const GUID cfg_artist_guid =
{ 0x8ada0c53, 0x2eb8, 0x4389, { 0x9f, 0xec, 0x45, 0x7d, 0x2c, 0x2c, 0x2c, 0x1 } };
// {2044EAE5-8FD5-4282-AE20-BADFFB9B2734}
static const GUID cfg_album_guid =
{ 0x2044eae5, 0x8fd5, 0x4282, { 0xae, 0x20, 0xba, 0xdf, 0xfb, 0x9b, 0x27, 0x34 } };
// {0AEABECE-2095-4df9-A4CD-C7B830B4D817}
static const GUID cfg_wmid_guid =
{ 0xaeabece, 0x2095, 0x4df9, { 0xa4, 0xcd, 0xc7, 0xb8, 0x30, 0xb4, 0xd8, 0x17 } };
// {B237DE44-D557-4d97-91AE-35A84079AEB8}
static const GUID cfg_wlmmode_guid =
{ 0xb237de44, 0xd557, 0x4d97, { 0x91, 0xae, 0x35, 0xa8, 0x40, 0x79, 0xae, 0xb8 } };
// {C98D5693-D8DA-4917-A091-26660ADC4691}
static const GUID cfg_msnformat_guid =
{ 0xc98d5693, 0xd8da, 0x4917, { 0xa0, 0x91, 0x26, 0x66, 0xa, 0xdc, 0x46, 0x91 } };

// {3C302EC1-92A8-4b14-8A01-0BC62F6F65B1}
static const GUID guid_cfg_enabled =
{ 0x3c302ec1, 0x92a8, 0x4b14, { 0x8a, 0x1, 0xb, 0xc6, 0x2f, 0x6f, 0x65, 0xb1 } };

static cfg_bool cfg_enabled(guid_cfg_enabled, true);

static cfg_string cfg_title(cfg_title_guid,"%title%");
static cfg_string cfg_artist(cfg_artist_guid,"%artist%");
static cfg_string cfg_album(cfg_album_guid,"%album%");
static cfg_string cfg_wmid(cfg_wmid_guid,"");
static cfg_bool cfg_wlmmode(cfg_wlmmode_guid,false);
static cfg_string cfg_msnformat(cfg_msnformat_guid,"{0} - {1}");

void clear_msn_title()
{
	stringcvt::string_wide_from_utf8 wbuffer(
		cfg_wlmmode ?
		"\\0Music\\00\\0\\0\\0\\0\\0" :
		"\\0Music\\00\\0{0} - {1}\\0\\0\\0\\0\\0"
	);
	msndata.dwData = 0x547;
	msndata.lpData = (void*)wbuffer.get_ptr();
	msndata.cbData = (wbuffer.length()*2)+2;

	HWND msnui = NULL;
	while (msnui = FindWindowExW(NULL, msnui, L"MsnMsgrUIManager", NULL))
		SendMessage(msnui, WM_COPYDATA, (WPARAM)NULL, (LPARAM)&msndata);
}
void show_msn_title(metadb_handle_ptr track)
;
void show_msn_title ()
{
    metadb_handle_ptr track;
    static_api_ptr_t<play_control>()->get_now_playing(track);
    if (track.is_valid())
    {
        show_msn_title(track);
        track.release();
    }
}

void show_msn_title(metadb_handle_ptr track)
{
	if (track.is_empty())
		return;


    static_api_ptr_t<titleformat_compiler> api;

	string8 artist8;

    service_ptr_t<titleformat_object> cfgArtist; //= titleformat_compiler
    api->compile (cfgArtist, cfg_artist);

	track->format_title(NULL, artist8, cfgArtist, NULL);
	string8 album8;

	string8 title8;
    service_ptr_t<titleformat_object> cfgTitle; //= titleformat_compiler
    api->compile (cfgTitle, cfg_title);
	track->format_title(NULL, title8, cfgTitle, NULL);


    service_ptr_t<titleformat_object> cfgAlbum; //= titleformat_compiler
    api->compile (cfgAlbum, cfg_album);

	track->format_title(NULL, album8, cfgAlbum, NULL);

    string8 wmid8;
    service_ptr_t<titleformat_object> cfgWmid; //= titleformat_compiler
    api->compile (cfgWmid, cfg_wmid);

	track->format_title(NULL, wmid8, cfgWmid, NULL);

	string8 buffer("\\0Music\\01\\0");
	if (!cfg_wlmmode)
	{
		buffer += cfg_msnformat;
		buffer += "\\0";
	}
    buffer += artist8;
	buffer += "\\0";
	buffer += title8;
	buffer += "\\0";
	buffer += album8;
	buffer += "\\0";
	buffer += wmid8;
	buffer += "\\0\\0";

	stringcvt::string_wide_from_utf8 wbuffer(buffer);
	msndata.dwData = 0x547;
	msndata.lpData = (void*)wbuffer.get_ptr();
	msndata.cbData = (wbuffer.length()*2)+2;

	HWND msnui = NULL;
	while (msnui = FindWindowExW(NULL, msnui, L"MsnMsgrUIManager", NULL))
		SendMessage(msnui, WM_COPYDATA, (WPARAM)NULL, (LPARAM)&msndata);
}

class play_callback_msn : public play_callback_static
{
	virtual void on_playback_starting(play_control::t_track_command p_command, bool p_paused) {}
	virtual void on_playback_new_track(metadb_handle_ptr p_track)
	{
        if (cfg_enabled)
		show_msn_title(p_track);
	}
	virtual void on_playback_stop(play_control::t_stop_reason p_reason)
	{
        if (cfg_enabled)
		clear_msn_title();
	}
	virtual void on_playback_seek(double p_time) {}
	virtual void on_playback_pause(bool p_state)
    {
        if (cfg_enabled)
        {
            if (p_state)
                clear_msn_title();
            else
            {
                metadb_handle_ptr track;
                static_api_ptr_t<play_control>()->get_now_playing(track);
                if (track.is_valid())
                {
                    show_msn_title(track);
                    track.release();
                }
            }
        }
	}
	virtual void on_playback_edited(metadb_handle_ptr p_track) {}
	virtual void on_playback_dynamic_info(const file_info & info) {}
	virtual void on_playback_dynamic_info_track(const file_info & info) {}
	virtual void on_playback_time(double p_time) {}
	virtual void on_volume_change(float p_new_val) {};

	virtual unsigned get_flags()
	{
		return flag_on_playback_new_track | flag_on_playback_pause | flag_on_playback_stop;
	}

};

// {F2C5A2E4-E46E-4a63-9E9B-FE64AECA466B}
static const GUID msn_prefs_guid =
{ 0xf2c5a2e4, 0xe46e, 0x4a63, { 0x9e, 0x9b, 0xfe, 0x64, 0xae, 0xca, 0x46, 0x6b } };

class config_foomsn : public preferences_page
{
	static BOOL CALLBACK ConfigProc(HWND wnd,UINT msg,WPARAM wp,LPARAM lp)
	{
		switch(msg)
		{
		case WM_INITDIALOG:
			uSetDlgItemText(wnd,IDC_ARTIST,cfg_artist);
			uSetDlgItemText(wnd,IDC_TITLE,cfg_title);
			uSetDlgItemText(wnd,IDC_ALBUM,cfg_album);
			uSetDlgItemText(wnd,IDC_WMID,cfg_wmid);
			uButton_SetCheck(wnd,IDC_WLMMODE,cfg_wlmmode);
			uSetDlgItemText(wnd,IDC_MSNFORMAT,cfg_msnformat);
			EnableWindow(GetDlgItem(wnd, IDC_MSNFORMAT), !cfg_wlmmode);
		break;
		case WM_COMMAND:
			switch(wp)
			{
			case (EN_KILLFOCUS<<16)|IDC_TITLE:
				cfg_title = string_utf8_from_window((HWND)lp);
				break;
			case (EN_KILLFOCUS<<16)|IDC_ARTIST:
				cfg_artist = string_utf8_from_window((HWND)lp);
				break;
			case (EN_KILLFOCUS<<16)|IDC_ALBUM:
				cfg_album = string_utf8_from_window((HWND)lp);
				break;
			case (EN_KILLFOCUS<<16)|IDC_WMID:
				cfg_wmid = string_utf8_from_window((HWND)lp);
				break;
			case IDC_WLMMODE:
				cfg_wlmmode = uButton_GetCheck(wnd,IDC_WLMMODE);
				EnableWindow(GetDlgItem(wnd, IDC_MSNFORMAT), !cfg_wlmmode);
				break;
			case (EN_KILLFOCUS<<16)|IDC_MSNFORMAT:
				cfg_msnformat = string_utf8_from_window((HWND)lp);
				break;
			}
		break;
		}
		return 0;
	}
public:
	virtual HWND create(HWND parent)
	{
		return uCreateDialog(IDD_CONFIG,parent,ConfigProc);
	}
	virtual const char * get_name() {return "MSN Now Playing";}
	virtual GUID get_guid() {return msn_prefs_guid;}
	virtual GUID get_parent_guid() {return guid_display;}
	virtual bool reset_query() {return false;}
	virtual void reset() {}
	virtual bool get_help_url(pfc::string_base & p_out) {
		p_out = "http://www.myplugins.info/";
		return true;
	}
};

/**************************
Providing menu commands.

Menu commands are one of the most important means for users
to interact with a general purpose component. (You may argue
that a component may have its own window with that the user
interacts most of the time, but how does the user open this
window? See?)

There are two basic types of menu commands: main menu and
context menu commands. This tutorial only uses main menu
commands.
**************************/

class mainmenu_commands_msnalt : public mainmenu_commands {
    // Return the number of commands we provide.
    virtual t_uint32 get_command_count() {
        return 1;
    }

    // All commands are identified by a GUID.
    virtual GUID get_command(t_uint32 p_index) {
        static const GUID guid_main_msnalt = { 0x7414fdb6, 0x6406, 0x4193, { 0xab, 0x20, 0xf3, 0x61, 0x48, 0x1b, 0x29, 0xd9 } };

        if (p_index == 0)
            return guid_main_msnalt;
        return pfc::guid_null;
    }

    // Set p_out to the name of the n-th command.
    // This name is used to identify the command and determines
    // the default position of the command in the menu.
    virtual void get_name(t_uint32 p_index, pfc::string_base & p_out) {
        if (p_index == 0)
            p_out = "Display now playing";
    }

    // Set p_out to the description for the n-th command.
    virtual bool get_description(t_uint32 p_index, pfc::string_base & p_out) {
        if (p_index == 0)
            p_out = "Show now playing in Windows live messenger";
        else
            return false;
        return true;
    }

    // Every set of commands needs to declare which group it belongs to.
    virtual GUID get_parent()
    {
        return mainmenu_groups::view;
    }

    // Execute n-th command.
    // p_callback is reserved for future use.
    virtual void execute(t_uint32 p_index, service_ptr_t<service_base> p_callback) {
        if (p_index == 0 && core_api::assert_main_thread()) {
            if (cfg_enabled)
            {
                cfg_enabled = false;
                clear_msn_title();
                // Hide and disable the window.
            }
            else
            {
                cfg_enabled = true;
                static_api_ptr_t<play_control> pCon;
                if (pCon ->is_playing () && !pCon->is_paused ())
                {
                    show_msn_title ();
                }
                // Show and enable the window.
            }
        }
    }

    // The standard version of this command does not support checked or disabled
    // commands, so we use our own version.
    virtual bool get_display(t_uint32 p_index, pfc::string_base & p_text, t_uint32 & p_flags)
    {
        p_flags = 0;
        if (is_checked(p_index))
            p_flags |= flag_checked;
        get_name(p_index,p_text);
        return true;
    }

    // Return whether the n-th command is checked.
    bool is_checked(t_uint32 p_index) {
        if (p_index == 0)
            return cfg_enabled;
        return false;
    }
};

static play_callback_static_factory_t<play_callback_msn> msn_callback_factory;
static preferences_page_factory_t<config_foomsn> msn_prefs_factory;

// We need to create a service factory for our menu item class,
// otherwise the menu commands won't be known to the system.
static mainmenu_commands_factory_t< mainmenu_commands_msnalt > foo_menu;


DECLARE_COMPONENT_VERSION("MSN Now Playing (alt)","2.4.2",0)
